Main Page | Class Hierarchy | Alphabetical List | Compound List | Compound Members

# IRiWidgets Struct Reference

Inherits IDispatch.

List of all members.

## Public Member Functions
HRESULT | ActivateWidget ([in] BSTR bszWidgetName,[in] BSTR bszAspectName,[in] BSTR bAnchorNodeName,[in] BSTR bszControlledNodeName)
HRESULT | AddWidget ([in] BSTR bszWidgetName,[in] BSTR bszAspectName,[in] BSTR bAnchorNodeName,[in] BSTR bszControlledNodeName)
HRESULT | ActivateViewWidget ([in] BSTR bszWidgetName,[in] BSTR bszAspectName,[in] BSTR bszViewNode)
HRESULT | ActivateToolWidget ([in] BSTR bszWidgetName,[in] BSTR bszAspectName)
HRESULT | ReplaceWidget ([in] BSTR bszGroupId,[in] BSTR bszWidgetName,[in] BSTR bszAspectName,[in] BSTR bszAnchorNodeName,[in] BSTR bszControlledNodeName)
HRESULT | ActivateDefaultWidget ()
HRESULT | SetWidgetGroupDependency ([in] BSTR bszSource,[in] BSTR bszDependent)
HRESULT | Move ([in] BSTR bszSelection,[in]VARIANT fWx,[in]VARIANT fWy,[in]VARIANT fWz)
HRESULT | Rotate ([in] BSTR bszSelection,[in]VARIANT fY,[in]VARIANT fP,[in]VARIANT fR,[in]VARIANT fWx,[in]VARIANT fWy,[in]VARIANT fWz)
HRESULT | Scale ([in] BSTR bszSelection,[in]VARIANT fscx,[in]VARIANT fscy,[in]VARIANT fscz,[in]VARIANT fshxy,[in]VARIANT fshxz,[in]VARIANT fshyz,[in]VARIANT fWx,[in]VARIANT fWy,[in]VARIANT fWz)
HRESULT | RotateWorld ([in] BSTR bszSelection,[in]VARIANT fY,[in]VARIANT fP,[in]VARIANT fR,[in]VARIANT fWx,[in]VARIANT fWy,[in]VARIANT fWz)
HRESULT | DeactivateDefaultWidgets ()

## Detailed Description

The IRiWidgets interface provides methods to work with Widget rosetta widget subsystem. It contains functions to activate, deactivate, replace widgets, to change group dependencies and also contains wrappers for some common widget actions (move, scale rotate);
Root-level name in the scripting engine's name space: Widgets

## Member Function Documentation

HRESULT IRiWidgets::ActivateWidget | ( | [in] BSTR | bszWidgetName,
|  | [in] BSTR | bszAspectName,
|  | [in] BSTR | bAnchorNodeName,
|  | [in] BSTR | bszControlledNodeName
| ) |

  | Activate specified widget. If widget path specifies encapsulator, widget activation procedure searches for most appripriate widget using automatic widget activation mechanism. Widget activation deactivates currently activated widget in the same group. Parameters:
  bszWidgetName | Widget node name or encapsulator with widgets in dependency graph
  bszAspectName | Initial aspect for widget.
  bszControlledNodeName | List of objects that will be controlled by widget. Objects are separated by ';'
Returns: standard HRESULT processing can be applied to returned value

HRESULT IRiWidgets::AddWidget | ( | [in] BSTR | bszWidgetName,
|  | [in] BSTR | bszAspectName,
|  | [in] BSTR | bAnchorNodeName,
|  | [in] BSTR | bszControlledNodeName
| ) |

  | Activate specified widget and add it to default widget group. If widget path specifies encapsulator, widget activation procedure searches for most appripriate widget using automatic widget activation mechanism. Parameters:
  bszWidgetName | Widget node name or encapsulator with widgets in dependency graph
  bszAspectName | Initial aspect for widget.
  bszControlledNodeName | List of objects that will be controlled by widget. Objects are separated by ';'
Returns: standard HRESULT processing can be applied to returned value

HRESULT IRiWidgets::ActivateViewWidget | ( | [in] BSTR | bszWidgetName,
|  | [in] BSTR | bszAspectName,
|  | [in] BSTR | bszViewNode
| ) |

  | Activate specified widget and add it to widget view widgets group. If widget path specifies encapsulator, widget activation procedure searches for most appripriate widget using automatic widget activation mechanism. Parameters:
  bszWidgetName | Widget node name or encapsulator with widgets in dependency graph
  bszAspectName | Initial aspect for widget.
  bszViewNode | List of objects that will be controlled by widget. For view widget, this may be '' as most likely this value will be probably updated by RnUpdateEyeCamera node or similar hook.
Returns: standard HRESULT processing can be applied to returned value

HRESULT IRiWidgets::ActivateToolWidget | ( | [in] BSTR | bszWidgetName,
|  | [in] BSTR | bszAspectName
| ) |

  | Activate specified widget and add it to widget tool widgets group. If widget path specifies encapsulator, widget activation procedure searches for most appripriate widget using automatic widget activation mechanism. Widget controlled nodes will be filled with current selection. Users may link RnSynchronizeWithSelection node to maintain this lists up to date. Parameters:
  bszWidgetName | Widget node name or encapsulator with widgets in dependency graph
  bszAspectName | Initial aspect for widget.
Returns: standard HRESULT processing can be applied to returned value

HRESULT IRiWidgets::ReplaceWidget | ( | [in] BSTR | bszGroupId,
|  | [in] BSTR | bszWidgetName,
|  | [in] BSTR | bszAspectName,
|  | [in] BSTR | bszAnchorNodeName,
|  | [in] BSTR | bszControlledNodeName
| ) |

  | Activate specified widget and add it to widget tool specified group. Activation deactivates all widgets in the specified group. If widget path specifies encapsulator, widget activation procedure searches for most appripriate widget using automatic widget activation mechanism. Parameters:
  bszGroupId | Specify group GUID to activate widget to.
  bszWidgetName | Widget node name or encapsulator with widgets in dependency graph
  bszAspectName | Initial aspect for widget.
  bszControlledNodeName | List of nodes.
Returns: standard HRESULT processing can be applied to returned value

HRESULT IRiWidgets::ActivateDefaultWidget | ( |  | ) |

| Activate widget from 'Widgets/Select' group. Returns: standard HRESULT processing can be applied to returned value

HRESULT IRiWidgets::SetWidgetGroupDependency | ( | [in] BSTR | bszSource,
|  | [in] BSTR | bszDependent
| ) |

  | Set widget dependency. If a widget group becomes deactivated, all dependent groups are also invalidated. Parameters:
  bszSource | Specify parent group GUID
  bszDependent | Specify children group GUID
Returns: standard HRESULT processing can be applied to returned value

HRESULT IRiWidgets::Move | ( | [in] BSTR | bszSelection,
|  | [in] VARIANT | fWx,
|  | [in] VARIANT | fWy,
|  | [in] VARIANT | fWz
| ) |

  | Move script command wrapper for widget Move actions. Parameters:
  bszSelection | specifies selected nodes.
  fWx | Displacement around X axis
  fWy | Displacement around Y axis
  fWz | Displacement around Z axis
Returns: standard HRESULT processing can be applied to returned value

HRESULT IRiWidgets::Rotate | ( | [in] BSTR | bszSelection,
|  | [in] VARIANT | fY,
|  | [in] VARIANT | fP,
|  | [in] VARIANT | fR,
|  | [in] VARIANT | fWx,
|  | [in] VARIANT | fWy,
|  | [in] VARIANT | fWz
| ) |

  | Rotate script command wrapper for widget Rotate actions. Parameters:
  bszSelection | specifies selected nodes.
  fY | Yaw
  fP | Pitch
  fR | Roll
  fWx | Displacement in X
  fWy | Displacement in Y
  fWz | Displacement in Z
Returns: standard HRESULT processing can be applied to returned value

HRESULT IRiWidgets::Scale | ( | [in] BSTR | bszSelection,
|  | [in] VARIANT | fscx,
|  | [in] VARIANT | fscy,
|  | [in] VARIANT | fscz,
|  | [in] VARIANT | fshxy,
|  | [in] VARIANT | fshxz,
|  | [in] VARIANT | fshyz,
|  | [in] VARIANT | fWx,
|  | [in] VARIANT | fWy,
|  | [in] VARIANT | fWz
| ) |

  | Scale script command wrapper for widget Scale actions. Parameters:
  bszSelection | specifies selected nodes.
  fscx | Scale around X axis
  fscy | Scale around Y axis
  fscz | Scale around Z axis
  fWx | Displacement in X
  fWy | Displacement in Y
  fWz | Displacement in Z
Returns: standard HRESULT processing can be applied to returned value

HRESULT IRiWidgets::RotateWorld | ( | [in] BSTR | bszSelection,
|  | [in] VARIANT | fY,
|  | [in] VARIANT | fP,
|  | [in] VARIANT | fR,
|  | [in] VARIANT | fWx,
|  | [in] VARIANT | fWy,
|  | [in] VARIANT | fWz
| ) |

  | Rotate script command wrapper for widget RotateWorld action. Rotation is performed by reversed multiplication. Parameters:
  bszSelection | specifies selected nodes.
  fY | Yaw
  fP | Pitch
  fR | Roll
  fWx | Displacement in X
  fWy | Displacement in Y
  fWz | Displacement in Z
Returns: standard HRESULT processing can be applied to returned value

HRESULT IRiWidgets::DeactivateDefaultWidgets | ( |  | ) |

| Deactivate default widgets group. Returns: standard HRESULT processing can be applied to returned value